OffsetGrabPoint (OpenMap API)
Date: 2016-12-09

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bbn.openmap.omGraphics
Class OffsetGrabPoint

    java.lang.Object
      com.bbn.openmap.omGraphics.geom.BasicGeometry
          com.bbn.openmap.omGraphics.OMGraphicAdapter
              com.bbn.openmap.omGraphics.OMPoint
                  com.bbn.openmap.omGraphics.GrabPoint
                      com.bbn.openmap.omGraphics.OffsetGrabPoint

All Implemented Interfaces:
  OMGeometry, OMGraphic, OMGraphicConstants, java.io.Serializable, java.lang.Cloneable

    public class OffsetGrabPoint

extends GrabPoint

An OffsetGrabPoint is one that manages other grab points. When it is moved, the other GrabPoints on its internal list are moved the same amount in pixel space.

See Also:
  Serialized Form

Nested Class Summary
`class` | `OffsetGrabPoint.Offset` A wrapper class of the internal GrabPoints.

Nested classes/interfaces inherited from class com.bbn.openmap.omGraphics.OMPoint
`OMPoint.Image`

Field Summary
`protected java.util.Hashtable<GrabPoint,OffsetGrabPoint.Offset>` | `offsetPoints` The list of GrabPoints to move when this point moves.
`protected boolean` | `overflowLock` Flag used as a lock to prevent StackOverflowErrors, in case this OffetGrabPoint is unwittingly a child of itself.

Fields inherited from class com.bbn.openmap.omGraphics.GrabPoint
`DEFAULT_RADIUS`

Fields inherited from class com.bbn.openmap.omGraphics.OMPoint
`DEFAULT_ISOVAL, lat1, lon1, oval, radius, x, y`

Fields inherited from class com.bbn.openmap.omGraphics.OMGraphicAdapter
`declutterType, displayPaint, edgeMatchesFill, fillPaint, hasLabel, linePaint, matted, mattingPaint, renderType, selected, selectPaint, showEditablePalette, stroke, textureMask`

Fields inherited from class com.bbn.openmap.omGraphics.geom.BasicGeometry
`attributes, lineType, needToRegenerate, shape, visible`

Fields inherited from interface com.bbn.openmap.omGraphics.OMGraphicConstants
`ADD_GRAPHIC_MASK, APP_OBJECT, BASIC_STROKE, CHANGE_APPEARANCE, clear, DECIMAL_DEGREES, DECLUTTERTYPE_LINE, DECLUTTERTYPE_MOVE, DECLUTTERTYPE_NONE, DECLUTTERTYPE_SPACE, DEFAULT_ROTATIONANGLE, DELETE_GRAPHIC_MASK, DESELECT_GRAPHIC_MASK, DESELECTALL_GRAPHIC_MASK, GRAPHICTYPE_ARC, GRAPHICTYPE_BITMAP, GRAPHICTYPE_CIRCLE, GRAPHICTYPE_ELLIPSE, GRAPHICTYPE_GRAPHIC, GRAPHICTYPE_GRID, GRAPHICTYPE_LINE, GRAPHICTYPE_POINT, GRAPHICTYPE_POLY, GRAPHICTYPE_RASTER, GRAPHICTYPE_RECTANGLE, GRAPHICTYPE_TEXT, INDEX, INFOLINE, LABEL, LINETYPE_GREATCIRCLE, LINETYPE_RHUMB, LINETYPE_STRAIGHT, LINETYPE_UNKNOWN, LOWER_GRAPHIC_MASK, LOWER_TO_BOTTOM_GRAPHIC_MASK, NO_ROTATE, OMGRAPHIC_ELT, OMGRAPHIC_TYPE_ATTR, RADIANS, RAISE_GRAPHIC_MASK, RAISE_TO_TOP_GRAPHIC_MASK, REMOVABLE, RENDERTYPE_LATLON, RENDERTYPE_OFFSET, RENDERTYPE_UNKNOWN, RENDERTYPE_XY, SELECT_GRAPHIC_MASK, SORT_GRAPHICS_MASK, TOOLTIP, UPDATE_GRAPHIC_MASK, UPDATED`

Constructor Summary
`OffsetGrabPoint(int x, int y)` Create the OffsetGrabPoint at a certain window location.
`OffsetGrabPoint(int x, int y, int radius)` Create the OffsetGrabPoint at a certain window location.

Method Summary
`GrabPoint` | `addGrabPoint(GrabPoint gp)` Add a GrabPoint to the internal list.
`void` | `clear()`
`protected void` | `finalize()`
`void` | `moveOffsets()` Go through all the Offset elements and changes their position on the map.
`GrabPoint` | `removeGrabPoint(GrabPoint rgp)` Remove a GrabPoint to the internal list.
`void` | `set()` Called when the other grab points may have moved, and the offset distances should be changed internally for the Offset objects.
`void` | `set(int x, int y)` Called when the position of the OffsetGrabPoint has moved.
`void` | `setX(int x)` Called when the X position of the OffsetGrabPoint has moved.
`void` | `setY(int y)` Called when the Y position of the OffsetGrabPoint has moved.
`void` | `updateOffsets()` Go through all the Offset elements and update the relative position to this grab point.

Methods inherited from class com.bbn.openmap.omGraphics.GrabPoint
`set, setDefaultDrawingAttributes`

Methods inherited from class com.bbn.openmap.omGraphics.OMPoint
`generate, getLat, getLon, getRadius, getX, getY, hasLineTypeChoice, isOval, restore, set, setLat, setLon, setOval, setRadius`

Methods inherited from class com.bbn.openmap.omGraphics.OMGraphicAdapter
`clone, deselect, distance, getDeclutterType, getDisplayColor, getDisplayPaint, getEdgeMatchesFill, getFillColor, getFillPaint, getHasLabel, getLineColor, getLinePaint, getMattingPaint, getRenderType, getSelectColor, getSelectPaint, getShowEditablePalette, getStroke, getTextureMask, initLabelingDuringGenerate, isClear, isMatted, isSelected, normalizeDistanceForLineWidth, readStroke, readTextureMask, regenerate, render, renderLabel, renderShape, select, setDeclutterType, setEdgeMatchesFill, setFillColor, setFillPaint, setGraphicsColor, setGraphicsForEdge, setGraphicsForFill, setHasLabel, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLabelLocation, setLineColor, setLinePaint, setMatted, setMattingPaint, setRenderType, setSelectColor, setSelected, setSelectPaint, setShowEditablePalette, setStroke, setTextureMask, shouldRenderEdge, shouldRenderFill, writeStroke, writeTextureMask`

Methods inherited from class com.bbn.openmap.omGraphics.geom.BasicGeometry
`_distance, appendShapeEdge, appendShapeEdge, appendShapeEdge, appendShapeEdge, clearAttributes, contains, createAttributeMap, createBoxShape, createShape, createShape, describeShapeDetail, describeShapeDetail, distanceToEdge, distanceToEdge, draw, draw, fill, fill, getAppObject, getAttribute, getAttributes, getDescription, getLineType, getNeedToRegenerate, getShape, isRenderable, isRenderable, isVisible, putAttribute, removeAttribute, setAppObject, setAttributes, setLineType, setNeedToRegenerate, setShape, setVisible`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.bbn.openmap.omGraphics.OMGraphic
`clone, deselect, getDeclutterType, getDisplayColor, getDisplayPaint, getFillColor, getFillPaint, getLineColor, getLinePaint, getMattingPaint, getRenderType, getSelectColor, getSelectPaint, getShowEditablePalette, getStroke, getTextureMask, isMatted, isSelected, normalizeDistanceForLineWidth, regenerate, renderLabel, select, setDeclutterType, setFillPaint, setGraphicsColor, setGraphicsForEdge, setGraphicsForFill, setLabelLocation, setLabelLocation, setLabelLocation, setLinePaint, setMatted, setMattingPaint, setRenderType, setSelected, setSelectPaint, setShowEditablePalette, setStroke, setTextureMask, shouldRenderEdge, shouldRenderFill`

Methods inherited from interface com.bbn.openmap.omGraphics.OMGeometry
`clearAttributes, contains, distance, distanceToEdge, draw, draw, fill, fill, getAppObject, getAttribute, getAttributes, getDescription, getLineType, getNeedToRegenerate, getShape, isRenderable, isRenderable, isVisible, putAttribute, removeAttribute, render, setAppObject, setAttributes, setLineType, setNeedToRegenerate, setShape, setVisible`

Field Detail

### offsetPoints

    protected java.util.Hashtable<GrabPoint,OffsetGrabPoint.Offset> offsetPoints

  The list of GrabPoints to move when this point moves.

### overflowLock

    protected boolean overflowLock

  Flag used as a lock to prevent StackOverflowErrors, in case this OffetGrabPoint is unwittingly a child of itself.

Constructor Detail

### OffsetGrabPoint

    public OffsetGrabPoint(int x,
                           int y)

  Create the OffsetGrabPoint at a certain window location.

  Parameters:
    `x` - horizontal pixel location from left side of window.
    `y` - vertical pixel location from top side of window.

### OffsetGrabPoint

    public OffsetGrabPoint(int x,
                           int y,
                           int radius)

  Create the OffsetGrabPoint at a certain window location.

  Parameters:
    `x` - horizontal pixel location from left side of window.
    `y` - vertical pixel location from top side of window.
    `radius` - the pixel radius of the point.

Method Detail

### addGrabPoint

    public GrabPoint addGrabPoint(GrabPoint gp)

  Add a GrabPoint to the internal list.

### removeGrabPoint

    public GrabPoint removeGrabPoint(GrabPoint rgp)

  Remove a GrabPoint to the internal list.

### set

    public void set(int x,
                    int y)

  Called when the position of the OffsetGrabPoint has moved. Does not adjust the offsets.

  Overrides:
    `set` in class `OMPoint`

### setX

    public void setX(int x)

  Called when the X position of the OffsetGrabPoint has moved. Does not adjust the offsets.

  Overrides:
    `setX` in class `OMPoint`

### setY

    public void setY(int y)

  Called when the Y position of the OffsetGrabPoint has moved. Does not adjust the offsets.

  Overrides:
    `setY` in class `OMPoint`

### set

    public void set()

  Called when the other grab points may have moved, and the offset distances should be changed internally for the Offset objects.

### moveOffsets

    public void moveOffsets()

  Go through all the Offset elements and changes their position on the map. Should be called when the OffsetGrabPoint has been moved and you want to move all the GrabPoints in its list.

### updateOffsets

    public void updateOffsets()

  Go through all the Offset elements and update the relative position to this grab point. Should be called when you set the position of the OffsetGrabPoint and you want to set the offset distances of all the GrabPoints in the internal list.

### clear

    public void clear()

### finalize

    protected void finalize()

  Overrides:
    `finalize` in class `java.lang.Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) BBNT Solutions LLC; See http://openmap.bbn.com/ for details